#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "ui_properties.h"
#include "properties.h"

#include "about.h"
#include "settings.h"
#include "ui_settings.h"

#include "QFile"
#include "qdirmodel.h"
#include "QtGui"
#include "QDirModel"
#include "QtCore"

#include "motion.h"

#include "mythread.h"


QProcess motion_Thread[10];
QProcess preview_Thread[10];

QString  video_device;

QString  MainWindow::web_Browser="firefox ";       //TERMİNAL COMMAND
QString  MainWindow::file_Browser="nautilus ";     //TERMİNAL COMMAND
QString  MainWindow::terminal="gnome-terminal -e ";//TERMİNAL COMMAND
QString  MainWindow::text_edit="gedit ";           //TERMİNAL COMMAND
QString  MainWindow::player="mplayer ";           //TERMİNAL COMMAND

QString MainWindow::webcam_Port;
QString MainWindow::target_Dir;
QString MainWindow::video_Device;
QString MainWindow::control_Port;
QString MainWindow::left_camera;

QProcess *program_control= new QProcess();
QString  program_info[10];
QString  program_name[10]={"motion",
                           "mplayer",
                           "gedit",
                           "kate",
                           "nautilus",
                           "dolphin",
                           "firefox",
                           "rekonq",
                           "gnome-terminal",
                           "konsole"};



QString MainWindow::daemonn;
QString MainWindow::process_id_file;
QString MainWindow::setup_mode;
QString MainWindow::videodevice;
QString MainWindow::v4l2_palette;
QString MainWindow::tunerdevice;
QString MainWindow::input;
QString MainWindow::norm;
QString MainWindow::frequency;
QString MainWindow::rotate;
QString MainWindow::widthn;
QString MainWindow::heightn;
QString MainWindow::framerate;
QString MainWindow::minimum_frame_time;
QString MainWindow::netcam_url;
QString MainWindow::netcam_userpass;
QString MainWindow::netcam_http;
QString MainWindow::netcam_proxy;
QString MainWindow::netcam_tolerant_check;
QString MainWindow::auto_brightness;
QString MainWindow::brightness;
QString MainWindow::contrast;
QString MainWindow::saturation;
QString MainWindow::hue;
QString MainWindow::roundrobin_frames;
QString MainWindow::roundrobin_skip;
QString MainWindow::switchfilter;
QString MainWindow::threshold;
QString MainWindow::threshold_tune;
QString MainWindow::noise_level;
QString MainWindow::noise_tune;
QString MainWindow::despeckle;
QString MainWindow::area_detect;
QString MainWindow::mask_file;
QString MainWindow::smart_mask_speed;
QString MainWindow::lightswitch;
QString MainWindow::minimum_motion_frames;
QString MainWindow::pre_capture;
QString MainWindow::post_capture;
QString MainWindow::gap;
QString MainWindow::max_mpeg_time;
QString MainWindow::output_all;
QString MainWindow::output_normal;
QString MainWindow::output_motion;
QString MainWindow::quality;
QString MainWindow::ppm;
QString MainWindow::ffmpeg_cap_new;
QString MainWindow::ffmpeg_cap_motion;
QString MainWindow::ffmpeg_timelapse;
QString MainWindow::ffmpeg_timelapse_mode;
QString MainWindow::ffmpeg_bps;
QString MainWindow::ffmpeg_variable_bitrate;
QString MainWindow::ffmpeg_video_codec;
QString MainWindow::ffmpeg_deinterlace;
QString MainWindow::snapshot_interval;
QString MainWindow::locate;
QString MainWindow::text_right;
QString MainWindow::text_left;
QString MainWindow::text_changes;
QString MainWindow::text_event;
QString MainWindow::text_double;
QString MainWindow::target_dir;
QString MainWindow::snapshot_filename;
QString MainWindow::jpeg_filename;
QString MainWindow::movie_filename;
QString MainWindow::timelapse_filename;
QString MainWindow::webcam_port;
QString MainWindow::webcam_quality;
QString MainWindow::webcam_motion;
QString MainWindow::webcam_maxrate;
QString MainWindow::webcam_localhost;
QString MainWindow::webcam_limit;
QString MainWindow::control_port;
QString MainWindow::control_localhost;
QString MainWindow::control_html_output;
QString MainWindow::control_authentication;
QString MainWindow::track_type;
QString MainWindow::track_auto;
QString MainWindow::track_port;
QString MainWindow::track_motorx;
QString MainWindow::track_motory;
QString MainWindow::track_maxx;
QString MainWindow::track_maxy;
QString MainWindow::track_iomojo_id;
QString MainWindow::track_step_angle_x;
QString MainWindow::track_step_angle_y;
QString MainWindow::track_move_wait;
QString MainWindow::track_speed;
QString MainWindow::track_stepsize;
QString MainWindow::quiet;
QString MainWindow::on_event_start;
QString MainWindow::on_event_end;
QString MainWindow::on_picture_save;
QString MainWindow::on_motion_detected;
QString MainWindow::on_area_detected;
QString MainWindow::on_movie_start;
QString MainWindow::on_movie_end;
QString MainWindow::on_camera_lost;
QString MainWindow::sql_log_image;
QString MainWindow::sql_log_snapshot;
QString MainWindow::sql_log_mpeg;
QString MainWindow::sql_log_timelapse;
QString MainWindow::sql_query;
QString MainWindow::mysql_db;
QString MainWindow::mysql_host;
QString MainWindow::mysql_user;
QString MainWindow::mysql_password;
QString MainWindow::pgsql_db;
QString MainWindow::pgsql_host;
QString MainWindow::pgsql_user;
QString MainWindow::pgsql_password;
QString MainWindow::pgsql_port;
QString MainWindow::video_pipe;
QString MainWindow::motion_video_pipe;

bool MainWindow::b_tunerdevice=FALSE;
bool MainWindow::b_netcam_url=FALSE;
bool MainWindow::b_netcam_userpass=FALSE;
bool MainWindow::b_netcam_http=FALSE;
bool MainWindow::b_netcam_proxy=FALSE;
bool MainWindow::b_area_detect=FALSE;
bool MainWindow::b_mask_file=FALSE;
bool MainWindow::b_text_left=FALSE;
bool MainWindow::b_control_authentication=FALSE;
bool MainWindow::b_track_port=FALSE;
bool MainWindow::b_on_event_start=FALSE;
bool MainWindow::b_on_event_end=FALSE;
bool MainWindow::b_on_picture_save=FALSE;
bool MainWindow::b_on_motion_detected=FALSE;
bool MainWindow::b_on_area_detected=FALSE;
bool MainWindow::b_on_movie_start=FALSE;
bool MainWindow::b_on_movie_end=FALSE;
bool MainWindow::b_on_camera_lost=FALSE;
bool MainWindow::b_mysql_db=FALSE;
bool MainWindow::b_mysql_host=FALSE;
bool MainWindow::b_mysql_user=FALSE;
bool MainWindow::b_mysql_password=FALSE;
bool MainWindow::b_pgsql_db=FALSE;
bool MainWindow::b_pgsql_host=FALSE;
bool MainWindow::b_pgsql_user=FALSE;
bool MainWindow::b_pgsql_password=FALSE;
bool MainWindow::b_pgsql_port=FALSE;
bool MainWindow::b_video_pipe=FALSE;
bool MainWindow::b_motion_video_pipe=FALSE;

QString MainWindow::c_tunerdevice;
QString MainWindow::c_netcam_url;
QString MainWindow::c_netcam_userpass;
QString MainWindow::c_netcam_http;
QString MainWindow::c_netcam_proxy;
QString MainWindow::c_area_detect;
QString MainWindow::c_mask_file;
QString MainWindow::c_text_left;
QString MainWindow::c_control_authentication;
QString MainWindow::c_track_port;
QString MainWindow::c_on_event_start;
QString MainWindow::c_on_event_end;
QString MainWindow::c_on_picture_save;
QString MainWindow::c_on_motion_detected;
QString MainWindow::c_on_area_detected;
QString MainWindow::c_on_movie_start;
QString MainWindow::c_on_movie_end;
QString MainWindow::c_on_camera_lost;
QString MainWindow::c_mysql_db;
QString MainWindow::c_mysql_host;
QString MainWindow::c_mysql_user;
QString MainWindow::c_mysql_password;
QString MainWindow::c_pgsql_db;
QString MainWindow::c_pgsql_host;
QString MainWindow::c_pgsql_user;
QString MainWindow::c_pgsql_password;
QString MainWindow::c_pgsql_port;
QString MainWindow::c_video_pipe;
QString MainWindow::c_motion_video_pipe;



MainWindow::MainWindow(QWidget *parent) :QMainWindow(parent),ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    program_intalled_Control();

    //    QProcess *list=new QProcess;

    //    list->start("bash -c \"ls /dev/video*\"",QIODevice::ReadWrite);
    //    list->waitForReadyRead();
    //    ui->textBrowser->append(list->readAll());
    //    QTableWidgetItem *ite=new QTableWidgetItem;
    //    ite->setText("gfafaf");
    //    ite->setText(QApplication::translate("MainWindow", "mfdafen", 0, QApplication::UnicodeUTF8));
    //    ui->tableWidget->insertRow(0);
    //    QTableWidgetItem *sd = ui->tableWidget->verticalHeaderItem(2);
    //    sd->setText("fdasfaewe");

    //    ui->tableWidget->setItem(0,1,ite);

    // MyThread *ser=new MyThread;
    // ser->start();
    //connect(ser,SIGNAL(rea(QString)),this,SLOT(ear(QString)));


}





MainWindow::~MainWindow()
{
    for(int number=0;number<10;number++)
    {
        motion_Thread[number].close();
        preview_Thread[number].close();

    }
    delete ui;

}
//-----------------------------CONFİG FİLE PATH-------------------------------------------
QString MainWindow::config_file_path(QString thread_name)
{
    return QDir::currentPath()+"/"+thread_name+".conf";
}
//-----------------------------RECONFİGURE CONFİG FİLE------------------------------------
void MainWindow::reconfigure_configfile(QString config_file,int i)
{//İF CONFİG FİLE NOT FOUN CREATE FİLE DEFAULT SETTİNGS

    qDebug()<<config_file_path("thread"+QString::number(i));

    control_Port=QString::number(8080+i);
    webcam_Port=QString::number(8080+i+1);
    target_Dir="/tmp/motion"+QString::number(i);
    video_Device="/dev/video"+QString::number(i);
    left_camera="CAMERA "+QString::number(i);

    QFile write(config_file_path(config_file));
    write.open(QIODevice::WriteOnly|QIODevice::Text);
    QTextStream out(&write);

    out
            <<"daemon off"<<endl
            <<"process_id_file /var/run/motion.pid"<<endl
            <<"setup_mode off"<<endl
            <<"videodevice "+video_Device<<endl
            <<"v4l2_palette 3"<<endl
            <<"; tunerdevice /dev/tuner0"<<endl
            <<"input 8"<<endl
            <<"norm 0"<<endl
            <<"frequency 0"<<endl
            <<"rotate 0"<<endl
            <<"width 320"<<endl
            <<"height 240"<<endl
            <<"framerate 2"<<endl
            <<"minimum_frame_time 0"<<endl
            <<"; netcam_url value"<<endl
            <<"; netcam_userpass value"<<endl
            <<"; netcam_http 1.0"<<endl
            <<"; netcam_proxy value"<<endl
            <<"netcam_tolerant_check off"<<endl
            <<"auto_brightness off"<<endl
            <<"brightness 0"<<endl
            <<"contrast 0"<<endl
            <<"saturation 0"<<endl
            <<"hue 0"<<endl
            <<"roundrobin_frames 1"<<endl
            <<"roundrobin_skip 1"<<endl
            <<"switchfilter off"<<endl
            <<"threshold 1500"<<endl
            <<"threshold_tune off"<<endl
            <<"noise_level 32"<<endl
            <<"noise_tune on"<<endl
            <<"despeckle EedDl"<<endl
            <<"; area_detect value"<<endl
            <<"; mask_file value"<<endl
            <<"smart_mask_speed 0"<<endl
            <<"lightswitch 0"<<endl
            <<"minimum_motion_frames 1"<<endl
            <<"pre_capture 0"<<endl
            <<"post_capture 0"<<endl
            <<"gap 60"<<endl
            <<"max_mpeg_time 0"<<endl
            <<"output_all off"<<endl
            <<"output_normal on"<<endl
            <<"output_motion off"<<endl
            <<"quality 75"<<endl
            <<"ppm off"<<endl
            <<"ffmpeg_cap_new on"<<endl
            <<"ffmpeg_cap_motion off"<<endl
            <<"ffmpeg_timelapse 0"<<endl
            <<"ffmpeg_timelapse_mode daily"<<endl
            <<"ffmpeg_bps 500000"<<endl
            <<"ffmpeg_variable_bitrate 0"<<endl
            <<"ffmpeg_video_codec mpeg4"<<endl
            <<"ffmpeg_deinterlace off"<<endl
            <<"snapshot_interval 0"<<endl
            <<"locate off"<<endl
            <<"text_right %Y-%m-%d\\n%T-%q"<<endl
            <<"; text_left "+left_camera<<endl
            <<"text_changes off"<<endl
            <<"text_event %Y%m%d%H%M%S"<<endl
            <<"text_double off"<<endl
            <<"target_dir "+target_Dir<<endl
            <<"snapshot_filename %v-%Y%m%d%H%M%S-snapshot"<<endl
            <<"jpeg_filename %v-%Y%m%d%H%M%S-%q"<<endl
            <<"movie_filename %v-%Y%m%d%H%M%S"<<endl
            <<"timelapse_filename %Y%m%d-timelapse"<<endl
            <<"webcam_port "+webcam_Port<<endl
            <<"webcam_quality 50"<<endl
            <<"webcam_motion off"<<endl
            <<"webcam_maxrate 1"<<endl
            <<"webcam_localhost on"<<endl
            <<"webcam_limit 0"<<endl
            <<"control_port "+control_Port<<endl
            <<"control_localhost on"<<endl
            <<"control_html_output on"<<endl
            <<"; control_authentication username:password"<<endl
            <<"track_type 0"<<endl
            <<"track_auto off"<<endl
            <<"; track_port value"<<endl
            <<"track_motorx 0"<<endl
            <<"track_motory 0"<<endl
            <<"track_maxx 0"<<endl
            <<"track_maxy 0"<<endl
            <<"track_iomojo_id 0"<<endl
            <<"track_step_angle_x 10"<<endl
            <<"track_step_angle_y 10"<<endl
            <<"track_move_wait 10"<<endl
            <<"track_speed 255"<<endl
            <<"track_stepsize 40"<<endl
            <<"quiet on"<<endl
            <<"; on_event_start value"<<endl
            <<"; on_event_end value"<<endl
            <<"; on_picture_save value"<<endl
            <<"; on_motion_detected value"<<endl
            <<"; on_area_detected value"<<endl
            <<"; on_movie_start value"<<endl
            <<"; on_movie_end value"<<endl
            <<"; on_camera_lost value"<<endl
            <<"sql_log_image on"<<endl
            <<"sql_log_snapshot on"<<endl
            <<"sql_log_mpeg off"<<endl
            <<"sql_log_timelapse off"<<endl
            <<"sql_query insert into security(camera, filename, frame, file_type, time_stamp, event_time_stamp) values('%t', '%f', '%q', '%n', '%Y-%m-%d %T', '%C')"<<endl
            <<"; mysql_db value"<<endl
            <<"; mysql_host value"<<endl
            <<"; mysql_user value"<<endl
            <<"; mysql_password value"<<endl
            <<"; pgsql_db value"<<endl
            <<"; pgsql_host value"<<endl
            <<"; pgsql_user value"<<endl
            <<"; pgsql_password value"<<endl
            <<"; pgsql_port 5432"<<endl
            <<"; video_pipe value"<<endl
            <<"; motion_video_pipe value";
    write.close();
}
//-----------------------------READ TOKEN-------------------------------------------------------
QString read_token(QStringList token)
{
    QStringList::iterator it;
    QString rota;

    rota = token.takeFirst();

    QString cache;

    for (it = token.begin(); it != token.end(); it++)
    {
        if(it == token.end().operator --()) cache.append(*it);
        else cache.append(*it+" ");
    }


    if(cache == "off") {cache = "0";}
    if(cache == "on" ) {cache = "1";}
    if(cache == "first" ) {cache = "2";}
    if(cache == "best" ) {cache = "3";}
    if(cache == "center" ) {cache = "4";}


    if(cache == "hourly")        {cache="0";}
    if(cache == "daily")         {cache="1";}
    if(cache == "weekly-sunday") {cache="2";}
    if(cache == "weekly-monday") {cache="3";}
    if(cache == "monthly")       {cache="4";}
    if(cache == "manual")        {cache="5";}

    if(rota=="rotate")
    {
        if(cache == "0")   {cache="0";}
        if(cache == "90")  {cache="1";}
        if(cache == "180") {cache="2";}
        if(cache == "270") {cache="3";}
    }

    if(cache == "1.0") {cache="0";}
    if(cache == "1.1") {cache="1";}

    if(cache == "mpeg1")  {cache="0";}
    if(cache == "mpeg4")  {cache="1";}
    if(cache == "msmpeg4"){cache="2";}
    if(cache == "swf")    {cache="3";}
    if(cache == "flv")    {cache="4";}
    if(cache == "ffv1")   {cache="5";}
    if(cache == "mov")    {cache="6";}


    if(cache == "/dev/video0") {video_device=cache; cache="0";}
    if(cache == "/dev/video1") {video_device=cache; cache="1";}
    if(cache == "/dev/video2") {video_device=cache; cache="2";}
    if(cache == "/dev/video3") {video_device=cache; cache="3";}
    if(cache == "/dev/video4") {video_device=cache; cache="4";}
    if(cache == "/dev/video5") {video_device=cache; cache="5";}
    if(cache == "/dev/video6") {video_device=cache; cache="6";}
    if(cache == "/dev/video7") {video_device=cache; cache="7";}
    if(cache == "/dev/video8") {video_device=cache; cache="8";}
    if(cache == "/dev/video9") {video_device=cache; cache="9";}
    if(cache == "/dev/video10"){video_device=cache; cache="10";}
    if(cache == "/dev/video11"){video_device=cache; cache="11";}


    return cache;

}
//-----------------------------READ CONFİG FİLE-------------------------------------------------
int MainWindow::read_configfile(QString config_file,int i)
{
    QStringList token;

    QFile       read(config_file_path(config_file));
    read.open(QIODevice::ReadOnly | QIODevice::Text);
    QTextStream in(&read);

    if(!read.exists())
    {
        reconfigure_configfile(config_file,i);
        return 0;
    }

    while (!in.atEnd())
    {
        QString line =in.readLine();

        token= line.split(" ");

        if(token.value(0)==";")
        {
            token.takeAt(0);

            if(token.value(0)=="tunerdevice"){b_tunerdevice=TRUE;}
            if(token.value(0)=="netcam_url"){b_netcam_url=TRUE;}
            if(token.value(0)=="netcam_userpass"){b_netcam_userpass=TRUE;}
            if(token.value(0)=="netcam_http"){b_netcam_http=TRUE;}
            if(token.value(0)=="netcam_proxy"){b_netcam_proxy=TRUE;}
            if(token.value(0)=="area_detect"){b_area_detect=TRUE;}
            if(token.value(0)=="mask_file"){b_mask_file=TRUE;}
            if(token.value(0)=="text_left"){b_text_left=TRUE;}
            if(token.value(0)=="control_authentication"){b_control_authentication=TRUE;}
            if(token.value(0)=="track_port"){b_track_port=TRUE;}
            if(token.value(0)=="on_event_start"){b_on_event_start=TRUE;}
            if(token.value(0)=="on_event_end"){b_on_event_end=TRUE;}
            if(token.value(0)=="on_picture_save"){b_on_picture_save=TRUE;}
            if(token.value(0)=="on_motion_detected"){b_on_motion_detected=TRUE;}
            if(token.value(0)=="on_area_detected"){b_on_area_detected=TRUE;}
            if(token.value(0)=="on_movie_start"){b_on_movie_start=TRUE;}
            if(token.value(0)=="on_movie_end"){b_on_movie_end=TRUE;}
            if(token.value(0)=="on_camera_lost"){b_on_camera_lost=TRUE;}
            if(token.value(0)=="mysql_db"){b_mysql_db=TRUE;}
            if(token.value(0)=="mysql_host"){b_mysql_host=TRUE;}
            if(token.value(0)=="mysql_user"){b_mysql_user=TRUE;}
            if(token.value(0)=="mysql_password"){b_mysql_password=TRUE;}
            if(token.value(0)=="pgsql_db"){b_pgsql_db=TRUE;}
            if(token.value(0)=="pgsql_host"){b_pgsql_host=TRUE;}
            if(token.value(0)=="pgsql_user"){b_pgsql_user=TRUE;}
            if(token.value(0)=="pgsql_password"){b_pgsql_password=TRUE;}
            if(token.value(0)=="pgsql_port"){b_pgsql_port=TRUE;}
            if(token.value(0)=="video_pipe"){b_video_pipe=TRUE;}
            if(token.value(0)=="motion_video_pipe"){b_motion_video_pipe=TRUE;}
        }


        if(token.value(0)=="daemon"){daemonn=read_token(token);}
        if(token.value(0)=="process_id_file"){process_id_file=read_token(token);}
        if(token.value(0)=="setup_mode"){setup_mode=read_token(token);}
        if(token.value(0)=="videodevice"){videodevice=read_token(token);}
        if(token.value(0)=="v4l2_palette"){v4l2_palette=read_token(token);}
        if(token.value(0)=="tunerdevice"){tunerdevice=read_token(token);}
        if(token.value(0)=="input"){input=read_token(token);}
        if(token.value(0)=="norm"){norm=read_token(token);}
        if(token.value(0)=="frequency"){frequency=read_token(token);}
        if(token.value(0)=="rotate"){rotate=read_token(token);}
        if(token.value(0)=="width"){widthn=read_token(token);}
        if(token.value(0)=="height"){heightn=read_token(token);}
        if(token.value(0)=="framerate"){framerate=read_token(token);}
        if(token.value(0)=="minimum_frame_time"){minimum_frame_time=read_token(token);}
        if(token.value(0)=="netcam_url"){netcam_url=read_token(token);}
        if(token.value(0)=="netcam_userpass"){netcam_userpass=read_token(token);}
        if(token.value(0)=="netcam_http"){netcam_http=read_token(token);}
        if(token.value(0)=="netcam_proxy"){netcam_proxy=read_token(token);}
        if(token.value(0)=="netcam_tolerant_check"){netcam_tolerant_check=read_token(token);}
        if(token.value(0)=="auto_brightness"){auto_brightness=read_token(token);}
        if(token.value(0)=="brightness"){brightness=read_token(token);}
        if(token.value(0)=="contrast"){contrast=read_token(token);}
        if(token.value(0)=="saturation"){saturation=read_token(token);}
        if(token.value(0)=="hue"){hue=read_token(token);}
        if(token.value(0)=="roundrobin_frames"){roundrobin_frames=read_token(token);}
        if(token.value(0)=="roundrobin_skip"){roundrobin_skip=read_token(token);}
        if(token.value(0)=="switchfilter"){switchfilter=read_token(token);}
        if(token.value(0)=="threshold"){threshold=read_token(token);}
        if(token.value(0)=="threshold_tune"){threshold_tune=read_token(token);}
        if(token.value(0)=="noise_level"){noise_level=read_token(token);}
        if(token.value(0)=="noise_tune"){noise_tune=read_token(token);}
        if(token.value(0)=="despeckle"){despeckle=read_token(token);}
        if(token.value(0)=="area_detect"){area_detect=read_token(token);}
        if(token.value(0)=="mask_file"){mask_file=read_token(token);}
        if(token.value(0)=="smart_mask_speed"){smart_mask_speed=read_token(token);}
        if(token.value(0)=="lightswitch"){lightswitch=read_token(token);}
        if(token.value(0)=="minimum_motion_frames"){minimum_motion_frames=read_token(token);}
        if(token.value(0)=="pre_capture"){pre_capture=read_token(token);}
        if(token.value(0)=="post_capture"){post_capture=read_token(token);}
        if(token.value(0)=="gap"){gap=read_token(token);}
        if(token.value(0)=="max_mpeg_time"){max_mpeg_time=read_token(token);}
        if(token.value(0)=="output_all"){output_all=read_token(token);}
        if(token.value(0)=="output_normal"){output_normal=read_token(token);}
        if(token.value(0)=="output_motion"){output_motion=read_token(token);}
        if(token.value(0)=="quality"){quality=read_token(token);}
        if(token.value(0)=="ppm"){ppm=read_token(token);}
        if(token.value(0)=="ffmpeg_cap_new"){ffmpeg_cap_new=read_token(token);}
        if(token.value(0)=="ffmpeg_cap_motion"){ffmpeg_cap_motion=read_token(token);}
        if(token.value(0)=="ffmpeg_timelapse"){ffmpeg_timelapse=read_token(token);}
        if(token.value(0)=="ffmpeg_timelapse_mode"){ffmpeg_timelapse_mode=read_token(token);}
        if(token.value(0)=="ffmpeg_bps"){ffmpeg_bps=read_token(token);}
        if(token.value(0)=="ffmpeg_variable_bitrate"){ffmpeg_variable_bitrate=read_token(token);}
        if(token.value(0)=="ffmpeg_video_codec"){ffmpeg_video_codec=read_token(token);}
        if(token.value(0)=="ffmpeg_deinterlace"){ffmpeg_deinterlace=read_token(token);}
        if(token.value(0)=="snapshot_interval"){snapshot_interval=read_token(token);}
        if(token.value(0)=="locate"){locate=read_token(token);}
        if(token.value(0)=="text_right"){text_right=read_token(token);}
        if(token.value(0)=="text_left"){text_left=read_token(token);}
        if(token.value(0)=="text_changes"){text_changes=read_token(token);}
        if(token.value(0)=="text_event"){text_event=read_token(token);}
        if(token.value(0)=="text_double"){text_double=read_token(token);}
        if(token.value(0)=="target_dir"){target_dir=read_token(token);}
        if(token.value(0)=="snapshot_filename"){snapshot_filename=read_token(token);}
        if(token.value(0)=="jpeg_filename"){jpeg_filename=read_token(token);}
        if(token.value(0)=="movie_filename"){movie_filename=read_token(token);}
        if(token.value(0)=="timelapse_filename"){timelapse_filename=read_token(token);}
        if(token.value(0)=="webcam_port"){webcam_port=read_token(token);}
        if(token.value(0)=="webcam_quality"){webcam_quality=read_token(token);}
        if(token.value(0)=="webcam_motion"){webcam_motion=read_token(token);}
        if(token.value(0)=="webcam_maxrate"){webcam_maxrate=read_token(token);}
        if(token.value(0)=="webcam_localhost"){webcam_localhost=read_token(token);}
        if(token.value(0)=="webcam_limit"){webcam_limit=read_token(token);}
        if(token.value(0)=="control_port"){control_port=read_token(token);}
        if(token.value(0)=="control_localhost"){control_localhost=read_token(token);}
        if(token.value(0)=="control_html_output"){control_html_output=read_token(token);}
        if(token.value(0)=="control_authentication"){control_authentication=read_token(token);}
        if(token.value(0)=="track_type"){track_type=read_token(token);}
        if(token.value(0)=="track_auto"){track_auto=read_token(token);}
        if(token.value(0)=="track_port"){track_port=read_token(token);}
        if(token.value(0)=="track_motorx"){track_motorx=read_token(token);}
        if(token.value(0)=="track_motory"){track_motory=read_token(token);}
        if(token.value(0)=="track_maxx"){track_maxx=read_token(token);}
        if(token.value(0)=="track_maxy"){track_maxy=read_token(token);}
        if(token.value(0)=="track_iomojo_id"){track_iomojo_id=read_token(token);}
        if(token.value(0)=="track_step_angle_x"){track_step_angle_x=read_token(token);}
        if(token.value(0)=="track_step_angle_y"){track_step_angle_y=read_token(token);}
        if(token.value(0)=="track_move_wait"){track_move_wait=read_token(token);}
        if(token.value(0)=="track_speed"){track_speed=read_token(token);}
        if(token.value(0)=="track_stepsize"){track_stepsize=read_token(token);}
        if(token.value(0)=="quiet"){quiet=read_token(token);}
        if(token.value(0)=="on_event_start"){on_event_start=read_token(token);}
        if(token.value(0)=="on_event_end"){on_event_end=read_token(token);}
        if(token.value(0)=="on_picture_save"){on_picture_save=read_token(token);}
        if(token.value(0)=="on_motion_detected"){on_motion_detected=read_token(token);}
        if(token.value(0)=="on_area_detected"){on_area_detected=read_token(token);}
        if(token.value(0)=="on_movie_start"){on_movie_start=read_token(token);}
        if(token.value(0)=="on_movie_end"){on_movie_end=read_token(token);}
        if(token.value(0)=="on_camera_lost"){on_camera_lost=read_token(token);}
        if(token.value(0)=="sql_log_image"){sql_log_image=read_token(token);}
        if(token.value(0)=="sql_log_snapshot"){sql_log_snapshot=read_token(token);}
        if(token.value(0)=="sql_log_mpeg"){sql_log_mpeg=read_token(token);}
        if(token.value(0)=="sql_log_timelapse"){sql_log_timelapse=read_token(token);}
        if(token.value(0)=="sql_query"){sql_query=read_token(token);}
        if(token.value(0)=="mysql_db"){mysql_db=read_token(token);}
        if(token.value(0)=="mysql_host"){mysql_host=read_token(token);}
        if(token.value(0)=="mysql_user"){mysql_user=read_token(token);}
        if(token.value(0)=="mysql_password"){mysql_password=read_token(token);}
        if(token.value(0)=="pgsql_db"){pgsql_db=read_token(token);}
        if(token.value(0)=="pgsql_host"){pgsql_host=read_token(token);}
        if(token.value(0)=="pgsql_user"){pgsql_user=read_token(token);}
        if(token.value(0)=="pgsql_password"){pgsql_password=read_token(token);}
        if(token.value(0)=="pgsql_port"){pgsql_port=read_token(token);}
        if(token.value(0)=="video_pipe"){video_pipe=read_token(token);}
        if(token.value(0)=="motion_video_pipe"){motion_video_pipe=read_token(token);}

    }read.close();
}
//-----------------------------PROGRAM INSTALLED CONTROL----------------------------------------
void MainWindow::program_intalled_Control()
{
    for(int number=0;number<10;number++)
    {
        program_control= new QProcess();
        program_control->start("which "+program_name[number],QIODevice::ReadOnly);
        program_control->waitForReadyRead();
        program_info[number]=program_control->readAll();
    }

    if(program_info[0]==NULL)  ui->textBrowser->append("Motion Gui need to work install motion");
    if(program_info[1]==NULL)  ui->textBrowser->append("preview need to work mplayer install  ");
    if(program_info[2]!=NULL)  text_edit="gedit ";
    if(program_info[3]!=NULL)  text_edit="kate ";
    if(program_info[4]!=NULL)  file_Browser="nautilus ";
    if(program_info[5]!=NULL)  file_Browser="dolphin ";
    if(program_info[6]!=NULL)  web_Browser="firefox ";
    if(program_info[7]!=NULL)  web_Browser="rekonq ";
    if(program_info[8]!=NULL)  terminal="gnome-terminal ";
    if(program_info[9]!=NULL)  terminal="konsole ";
}
//-----------------------------FONCTİON---------------------------------------------------------
void MainWindow::fonction(QString thread_name,int number,QString browser)
{
    QProcess *command = new QProcess();
    //FILE CONTROL
    if(read_configfile(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex()) == 0)
    {
        ui->textBrowser->append("Created Default Settings  " + config_file_path(ui->configfile_comboBox->currentText()));

    }else{
        ui->textBrowser->append("Opened    " + config_file_path(ui->configfile_comboBox->currentText()));
    }

    read_configfile(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex());
    //FILE FUCTİON
    if(browser=="file")
    {
        if(!QDir(target_dir).exists())//if targer dir directory not found create it
        {
            QDir().mkdir(target_dir);
        }
        ui->textBrowser->append("# "+file_Browser+target_dir);
        command->start(file_Browser+"\""+target_dir+"\"",QIODevice::ReadWrite);
    }
    //HTTP FUNCTİON
    if(browser=="http")
    {
        if(motion_Thread[number].pid()!=NULL)
        {
            if(number==1)
            {
                ui->textBrowser->append("# "+web_Browser+" http://localhost:"+ webcam_port);
                //command->start(web_Browser+" http://localhost:"+ webcam_port,QIODevice::ReadWrite);
                command->start("vlc --width=100 --height=300   http://localhost:"+ webcam_port,QIODevice::ReadWrite);


            }
            if(number==2)
            {
                ui->textBrowser->append("# "+web_Browser+" http://localhost:"+ control_port);
                command->start(web_Browser+" http://localhost:"+ control_port,QIODevice::ReadWrite);
            }

        }else{ui->textBrowser->append("Not Running \""+ thread_name + "\"");}
    }
    //START FUNCTİON
    if(browser=="start")
    {
        if(!QDir(target_dir).exists())
        {
            QDir().mkdir(target_dir);
        }

        if(motion_Thread[number].pid()==NULL)
        {
            QString video_device_list;
            program_control->start("ls "+video_device,QIODevice::ReadOnly);
            program_control->waitForReadyRead();
            video_device_list=program_control->readAll();
            qDebug()<<video_device_list;
            if(video_device_list!=NULL)
            {
                preview_Thread[number].kill();
                ui->textBrowser->append("\n # motion -c "+config_file_path(thread_name));
                motion_Thread[number].start("motion -c \""+config_file_path(thread_name)+"\"",QIODevice::ReadWrite);

                motion_Thread[number].waitForReadyRead(1000);


                ui->textBrowser->append(motion_Thread[number].readAllStandardError());                
                ui->textBrowser->append("# Started \""+thread_name+"\" Pid number : "+QString::number(motion_Thread[number].pid()));


                QListWidgetItem *thread_Item=new QListWidgetItem;
                QIcon icon;
                icon.addFile(QString::fromUtf8(":/new/webcam/Webcam.ico"), QSize(), QIcon::Normal, QIcon::Off);
                thread_Item->setIcon(icon);
                thread_Item->setText(thread_name+ " Pid number : " +QString::number(motion_Thread[number].pid()));
                ui->listWidget->addItem(thread_Item);

            }else{ui->textBrowser->append("! No Video Device Found "+video_device);}

        }else{ui->textBrowser->append("Already Running \""+thread_name+"\" Pid number : "+QString::number(motion_Thread[number].pid()));}
    }
    // STOP FUNCTİON
    if(browser=="stop")
    {

        for(int i=0;i<ui->listWidget->count();i++)
        {
            ui->textBrowser->append(ui->listWidget->item(i)->text());

            if(ui->listWidget->item(i)->text()==(thread_name+ " Pid number : " +QString::number(motion_Thread[number].pid())) )
            {
                ui->listWidget->takeItem(i);
            }

        }
        if(motion_Thread[number].pid()!=NULL)
        {
            ui->textBrowser->append("# Stopped \""+thread_name+"\" Pid number : "+QString::number(motion_Thread[number].pid()));
            motion_Thread[number].close();
        }else{ui->textBrowser->append("# No running Thread ");}
    }
    //EDİT FUNCTİON
    if(browser=="edit")
    {
        ui->textBrowser->append("# "+text_edit+" "+config_file_path(thread_name));
        command->start(text_edit+" \""+config_file_path(thread_name)+"\"",QIODevice::ReadWrite);
    }
    //PREVİEW FUNCTİON
    if(browser=="preview")
    {
        if(motion_Thread[number].pid()==NULL)
        {

            program_control->start("ls "+video_device,QIODevice::ReadOnly);
            program_control->waitForReadyRead();
            program_info[0]=program_control->readAll();

            if(program_info[0]!=NULL)
            {
                if(preview_Thread[number].pid()==NULL)
                {
                    ui->textBrowser->append("# mplayer tv:// -tv driver=v4l2:width=320:height=240:device="+video_device);
                    preview_Thread[number].start("mplayer -title \""+thread_name+"  "+video_device+"\" tv:// -tv driver=v4l2:width=320:height=240:device="+video_device,QIODevice::ReadWrite);
                }else{ui->textBrowser->append("Already Running Program ");}
            }else{ui->textBrowser->append("! No Video Device Found "+video_device);}

        }else{ui->textBrowser->append("Already Running \""+thread_name+"\" If preview starting stop this thread");}
    }

}


//-----------------------------CONFİGURE BUTTON--------------------------------------------------
void MainWindow::on_configure_button_clicked()
{//İF FİLE NOT FOUN CREATE FİLE

    if(read_configfile(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex()) == 0)
    {
        ui->textBrowser->append("Created Default Settings  " + config_file_path(ui->configfile_comboBox->currentText()));        

    }else{
        ui->textBrowser->append("Opened    " + config_file_path(ui->configfile_comboBox->currentText()));
    }

    read_configfile(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex());

    properties dia;
    dia.setWindowTitle(ui->configfile_comboBox->currentText());
    dia.show();
    dia.exec();
}
//-----------------------------STOP THREAD BUTTON------------------------------------------------
void MainWindow::on_stop_button_clicked()
{
    fonction(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex(),"stop");
}
//-----------------------------START THREAD BUTTON-----------------------------------------------
void MainWindow::on_start_button_clicked()
{
    fonction(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex(),"start");
}
//-----------------------------FILE BROWSER BUTTON-----------------------------------------------
void MainWindow::on_file_button_clicked()
{
    fonction(ui->configfile_comboBox->currentText(),0,"file");
}
//-----------------------------WEB BROWSER BUTTON------------------------------------------------
void MainWindow::on_webbrowser_button_clicked()
{//READ CONFİG FİLE 67. WEBCAM PORT
    fonction(ui->configfile_comboBox->currentText(),1,"http");
}
//-----------------------------WEB CONTROL BUTTON------------------------------------------------
void MainWindow::on_web_Control_clicked()
{//READ CONFİG FİLE 73.CONTROL PORT
    fonction(ui->configfile_comboBox->currentText(),2,"http");
}
//-----------------------------CONFİG FİLE EDİT BUTTON-------------------------------------------
void MainWindow::on_pushButton_clicked()
{
    fonction(ui->configfile_comboBox->currentText(),0,"edit");
}
//-----------------------------PREVİEW BUTTON----------------------------------------------------
void MainWindow::on_preView_clicked()
{
    fonction(ui->configfile_comboBox->currentText(),ui->configfile_comboBox->currentIndex(),"preview");
}
//-----------------------------ABOUT BUTTON------------------------------------------------------
void MainWindow::on_actionAbout_triggered()
{

    About *ab=new About;
    ab->show();

}
//-----------------------------SETTİNGS BUTTON---------------------------------------------------
void MainWindow::on_actionSettings_triggered()
{
    settings *set=new settings;
    set->ui->file_Browser_lineEdit->setText(file_Browser);
    set->ui->web_Browser_lineEdit->setText(web_Browser);
    set->ui->terminal_lineEdit->setText(terminal);
    set->ui->player_lineEdit->setText(player);
    set->ui->tex_Editor_lineEdit->setText(text_edit);

    set->show();
}
//-----------------------------MOTİON BUTTON-----------------------------------------------------
void MainWindow::ear(QString desa)
{
    ui->textBrowser->append(desa);

}
