#ifndef PROPERTIES_H
#define PROPERTIES_H

#include <QDialog>
#include "mainwindow.h"

namespace Ui {
    class properties;
}

class properties : public QDialog
{
    Q_OBJECT

public:
    explicit properties(QWidget *parent = 0);
    ~properties();

private slots:
    void on_buttonBox_accepted();

    void on_reset_all_Setttings_clicked();  

    void on_tunerdevice_checkBox_stateChanged(int );

    void on_netcam_url_checkBox_stateChanged(int );

    void on_netcam_userpass_checkBox_stateChanged(int );

    void on_netcam_http_checkBox_stateChanged(int );

    void on_netcam_proxy_checkBox_stateChanged(int );

    void on_on_event_start_checkBox_stateChanged(int );

    void on_on_event_end_checkBox_stateChanged(int );

    void on_on_picture_save_checkBox_stateChanged(int );

    void on_on_motion_detected_checkBox_stateChanged(int );

    void on_mysql_db_checkBox_stateChanged(int );

    void on_mysql_host_checkBox_stateChanged(int );

    void on_mysql_user_checkBox_stateChanged(int );

    void on_mysql_password_checkBox_stateChanged(int );

    void on_pgsql_db_checkBox_stateChanged(int );

    void on_pgsql_host_checkBox_stateChanged(int );

    void on_pgsql_user_checkBox_stateChanged(int );

    void on_pgsql_password_checkBox_stateChanged(int );

    void on_pgsql_port_checkBox_stateChanged(int );

    void on_on_camera_lost_checkBox_stateChanged(int );

    void on_on_movie_end_checkBox_stateChanged(int );

    void on_on_movie_start_checkBox_stateChanged(int );

    void on_on_area_detected_checkBox_stateChanged(int );

    void on_track_port_checkBox_stateChanged(int );

    void on_control_authentication_checkBox_stateChanged(int );

    void on_area_detect_checkBox_stateChanged(int );

    void on_mask_file_checkBox_stateChanged(int );

    void on_text_left_checkBox_stateChanged(int );

    void on_video_pipe_checkBox_stateChanged(int );

    void on_motion_video_pipe_checkBox_stateChanged(int );

public:
    Ui::properties *ui;

};

#endif // PROPERTIES_H
