#include "settings.h"
#include "ui_settings.h"

#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "qxmlstream.h"
#include "QFile"
#include "QDir"

settings::settings(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::settings)
{
    ui->setupUi(this);
}

settings::~settings()
{
    delete ui;
}

void settings::on_pushButton_clicked()
{

    MainWindow *mw2;
    mw2->file_Browser=ui->file_Browser_lineEdit->text();
    mw2->web_Browser=ui->web_Browser_lineEdit->text();
    mw2->terminal=ui->terminal_lineEdit->text();
    mw2->player=ui->player_lineEdit->text();
    mw2->text_edit=ui->tex_Editor_lineEdit->text();

    QFile write(QDir::currentPath()+"/settings.xml");
    write.open(QIODevice::ReadWrite);
    QXmlStreamWriter xml_Write(&write);

    xml_Write.writeStartDocument();
    xml_Write.writeStartElement("");
    xml_Write.writeEndDocument();


}
